Index: hiki/filter/bayes_filter/bayes.rb
===================================================================
--- hiki/filter/bayes_filter/bayes.rb	(.../vender/HikiWiki.org/hiki-1.0.0/hiki/filter/bayes_filter/bayes.rb)	(revision 565)
+++ hiki/filter/bayes_filter/bayes.rb	(.../trunk/public:amorita/hiki-1.0.0/hiki/filter/bayes_filter/bayes.rb)	(revision 565)
@@ -7,36 +7,27 @@
 module Bayes
 	module CHARSET
 		def self.setup_re(m)
-			o = $KCODE
-			$KCODE = m::KCODE
 			m.const_set(:RE_MESSAGE_TOKEN, Regexp.union(m::RE_KATAKANA, m::RE_KANJI, /[a-zA-Z]+/))
-			$KCODE=o
 		end
 
 		module EUC
 			KCODE = "e"
-			KATAKANA = "\xa5\xa2-\xa5\xf3"
-			BAR = "\xa1\xbc"
-			KANJI = "\xb0\xa1-\xfc\xfe"
-			RE_KATAKANA = /[#{KATAKANA}#{BAR}]{2,}/eo
-			RE_KANJI = /[#{KANJI}]{2,}/eo
+			KATAKANA = "\xa5\xa2-\xa5\xf3".force_encoding("EUC-JP")
+			BAR = "\xa1\xbc".force_encoding("EUC-JP")
+			KANJI = "\xb0\xa1-\xfc\xfe".force_encoding("EUC-JP")
+			RE_KATAKANA = /[#{KATAKANA}#{BAR}]{2,}/o
+			RE_KANJI = /[#{KANJI}]{2,}/o
 
 			CHARSET.setup_re(self)
 		end
 
 		module UTF8
 			KCODE = "u"
-			def self.c2u(c)
-				[c].pack("U")
-			end
-			def self.utf_range(a, b)
-				"#{c2u(a)}-#{c2u(b)}"
-			end
-			KATAKANA = utf_range(0x30a0, 0x30ff)
-			BAR = c2u(0x30fc)
-			KANJI = utf_range(0x4e00, 0x9faf)
-			RE_KATAKANA = /[#{KATAKANA}#{BAR}]{2,}/uo
-			RE_KANJI = /[#{KANJI}]{2,}/uo
+			KATAKANA = "\u30a0-\u30ff".force_encoding("UTF-8")
+			BAR = "\u30fc".force_encoding("UTF-8")
+			KANJI = "\u4e00-\u9faf".force_encoding("UTF-8")
+			RE_KATAKANA = /[#{KATAKANA}#{BAR}]{2,}/o
+			RE_KANJI = /[#{KANJI}]{2,}/o
 
 			CHARSET.setup_re(self)
 		end
@@ -48,7 +39,7 @@
 		def initialize(charset=nil)
 			unless charset
 				charset =
-					case $KCODE
+					case Encoding.default_external.to_s.downcase
 					when /^e/i
 						CHARSET::EUC
 					else
